package com.fp.persistence.pcustomer.gene;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TCUSTPERSON*/
@Entity(name="TcustPerson")
@Table(name="TCUSTPERSON")
public class TcustPerson extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TcustPerson
*/
@Id
@Column(name="PERSONCODE" ,nullable=false, updatable=false)
private Integer pk;
/**Contructor por defecto*/
public TcustPerson(){
}
/**Contructor de TcustPerson
@param pPk Clave Primaria del entity
*/
public TcustPerson(Integer pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TcustPerson
*/
public static TcustPerson find(EntityManager pEntityManager,Object pKey) throws Exception{
    TcustPerson obj = pEntityManager.find(TcustPerson.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TcustPerson
@return El objeto que referencia a la Clave primaria de TcustPerson
*/
public Integer getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TcustPerson
@param pPk El objeto que referencia a la nueva Clave primaria de TcustPerson
*/
public void setPk(Integer pPk){
  pk=pPk;
}
public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TcustPerson))return false;
    TcustPerson that = (TcustPerson) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TcustPerson
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TcustPerson
*/
public Object createInstance(){
 TcustPerson instance=new TcustPerson();	
 return instance;
}
/**Clona la entidad TcustPerson
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TcustPerson p=(TcustPerson)this.clone();
  return p;
}
}
